#include once "fbgfx.bi"
#include once "xmlparse.bi"

' Darstellungsoptionen
#define MINALPHA    63             ' je kleiner, desto dunkler wird der Rand
#define STEINBREITE 20             ' Faktor fuer die Breite der Steine
#define STEINHOEHE  25             ' (Gesamt-)Hoehe eines Steins
#define VORDERGRUNDFARBE &h000000
#define HINTERGRUNDFARBE &h7f7fff
#define PFEILFARBE       &hffffff
#define FENSTERBREITE    800
#define FENSTERHOEHE     600

' Spieltechnische Optionen fuer den Levelstart
#define ERZWINGE_MAXBREITE    -1   ' Steine breiter als der Stock?
#define ERZWINGE_REIHENFOLGE   0   ' breitere Steine auf schmaleren?
#define ERZWINGE_FARBE         0   ' Steine mit anderer Farbe als Stock?

' Stock-Arten
#define PYRAMIDE     1
#define EINFARBIG    2

screenres FENSTERBREITE, FENSTERHOEHE, 32
width FENSTERBREITE\8, FENSTERHOEHE\16
color VORDERGRUNDFARBE, HINTERGRUNDFARBE

dim shared as FB.IMAGE ptr maske(16)
dim shared as uinteger farbwert(16)
farbwert( 0) = rgb(210, 165,  30)
farbwert( 1) = rgb(255,  31,  31)
farbwert( 2) = rgb( 31, 255,  31)
farbwert( 3) = rgb( 31,  31, 255)
farbwert( 4) = rgb(255, 255,  31)
farbwert( 5) = rgb( 31, 255, 255)
farbwert( 6) = rgb(255,  31, 250)
farbwert( 7) = rgb(255, 127,   0)
farbwert( 8) = rgb(127, 127, 127)
farbwert( 9) = rgb(127,   0,  20)
farbwert(10) = rgb(  0, 127,  20)
farbwert(11) = rgb(  0,   0, 127)
farbwert(12) = rgb(127, 127,   0)
farbwert(13) = rgb(  0, 127, 127)
farbwert(14) = rgb(127,   0, 127)
farbwert(15) = rgb(127,  63,   0)
farbwert(16) = rgb(255, 255, 255)

type TypStein
  as integer farbe, breite, typ
end type

type TypStock
  as integer breite, laenge, farbe, typ, posX, posY, anzSteine
  as TypStein stein(20)
  declare constructor
  declare function setzeStein(farbe as integer, breite as integer) as integer
  declare function schiebeStein(ziel as TypStock) as integer
  declare sub zeichnen
end type

declare function laden(level as string, stock() as TypStock) as integer
declare sub zeichneStein(x as integer, y as integer, f as integer, byval b as integer, f2 as integer = 0, typ as integer = 0)

constructor TypStock
end constructor

function TypStock.setzeStein(farbe as integer, breite as integer) as integer
  if this.anzSteine >= this.laenge then return 0
  #if ERZWINGE_MAXBREITE
    if this.breite < breite then return 0
  #endif
  #if ERZWINGE_FARBE
    if this.typ and EINFARBIG andalso this.farbe <> farbe then return 0
  #endif
  #if ERZWINGE_REIHENFOLGE
    if this.anzSteine > 0 then
      if this.stein(this.anzSteine-1).breite < breite then return 0
      if this.typ and PYRAMIDE andalso this.anzSteine > 0 andalso this.stein(this.anzSteine-1).breite = breite then return 0
    end if
  #endif
  this.stein(this.anzSteine) = type<TypStein>(farbe, breite)
  this.anzSteine += 1
end function

function TypStock.schiebeStein(ziel as TypStock) as integer
  if this.anzSteine < 1 or ziel.anzSteine >= ziel.laenge then return 0
  with this.stein(this.anzSteine-1)
    if ziel.breite < .breite then return 0
    if ziel.breite = .breite andalso this.typ and PYRAMIDE then return 0
    if ziel.anzSteine > 0 then
      if ziel.stein(ziel.anzSteine-1).breite < .breite then return 0
      if ziel.stein(ziel.anzSteine-1).breite = .breite andalso ziel.stein(ziel.anzSteine-1).typ and PYRAMIDE then return 0
    end if
    if ziel.typ and PYRAMIDE andalso ziel.anzSteine > 0 andalso ziel.stein(ziel.anzSteine-1).breite = .breite then return 0
    if ziel.typ and EINFARBIG andalso .farbe <> ziel.farbe then return 0
    ziel.stein(ziel.anzSteine) = this.stein(this.anzSteine-1)
    ziel.anzSteine += 1
    this.anzSteine -= 1
  end with
  return -1
end function

sub TypStock.zeichnen
  with this
    line (.posX-(STEINBREITE\2)*(.breite+1), .posY)-step(STEINBREITE*(.breite+1), -STEINHOEHE*(.laenge+1)), HINTERGRUNDFARBE, bf
    zeichneStein .posX-(STEINBREITE\2)*(.breite+1), .posY-STEINHOEHE, 0, .breite, .farbe, .typ
    for i as integer = 1 to .laenge
      zeichneStein .posX-STEINBREITE\2, .posY-STEINHOEHE*(i+1), 0, 0, iif(.typ and EINFARBIG, .farbe, 0)
      if .anzSteine >= i then
        zeichneStein .posX-(STEINBREITE\2)*(.stein(i-1).breite+1), .posY-STEINHOEHE*(i+1), _
                     .stein(i-1).farbe, .stein(i-1).breite,, .stein(i-1).typ
      end if
    next
  end with
end sub

dim as TypStock stock(9)
dim as integer anzStoecke, mx, my, mb, start, startbreite, startfarbe, starttyp, ziel, mxPlus, myPlus
dim as integer levelMax = 0, siegbedingung(16), sieg, zuege
dim as FB.IMAGE ptr hintergrund = imagecreate(FENSTERBREITE, FENSTERHOEHE), pfeil
dim as string taste

do while len(dir("level/level" & (levelMax+1) & ".xml"))
  levelMax += 1
loop

' Grafik vorbereiten
for m as integer = 0 to 16
  maske(m) = imagecreate((m+1)*STEINBREITE, STEINHOEHE)
  for x as integer = 0 to (m+1)*STEINBREITE - 1
    for y as integer = 0 to STEINHOEHE - 1
      pset maske(m), (x, y), rgba(255, 255, 255, 255-((255-MINALPHA)/((m+1)*(STEINBREITE\2)))*abs((m+1)*(STEINBREITE\2)-x))
    next
  next
next
pfeil = imagecreate(3*STEINBREITE, 3*STEINBREITE, &hff00ff)
line pfeil, (1.5*STEINBREITE-1, 0)-(0, 1.5*STEINBREITE-1), PFEILFARBE
line pfeil, -(STEINBREITE-1, 1.5*STEINBREITE-1), PFEILFARBE
line pfeil, -(STEINBREITE-1, 3*STEINBREITE-1), PFEILFARBE
line pfeil, -(2*STEINBREITE-1, 3*STEINBREITE-1), PFEILFARBE
line pfeil, -(2*STEINBREITE-1, 1.5*STEINBREITE-1), PFEILFARBE
line pfeil, -(3*STEINBREITE-1, 1.5*STEINBREITE-1), PFEILFARBE
line pfeil, -(1.5*STEINBREITE-1, 0), PFEILFARBE
paint pfeil, (1.5*STEINBREITE, 1.5*STEINBREITE), PFEILFARBE, PFEILFARBE

dim as integer level = 1
do
  erase stock, siegbedingung
  anzStoecke = laden("level" & level, stock())
  windowtitle "Hanoxi - Level " & level
  cls
  for i as integer = 0 to anzStoecke - 1
    stock(i).zeichnen
    siegbedingung(stock(i).farbe) = -1
  next
  if anzStoecke = 0 then
    locate FENSTERHOEHE\32, FENSTERBREITE\16 - 12
    print "FEHLERHAFTE LEVEL-DATEI!"
  end if

  zuege = 0
  locate 2, 5
  print !"ben\148tigte Z\129ge: 0"
  do
    getmouse mx, my,, mb
    if mb = 1 then
      start = -1
      for i as integer = 0 to anzStoecke - 1
        with stock(i)
          if .anzSteine > 0 _
               andalso my > .posY-STEINHOEHE*(.anzSteine+1) and my < .posY-STEINHOEHE*(.anzSteine) _
               and mx > .posX-(STEINBREITE\2)*(.stein(.anzSteine-1).breite+1) _
               and mx < .posX+(STEINBREITE\2)*(.stein(.anzSteine-1).breite+1) then
            start = i
            mxPlus = mx - .posX + (STEINBREITE\2)*(.stein(.anzSteine-1).breite+1)
            myPlus = my - .posY + STEINHOEHE*(.anzSteine+1)
            startfarbe  = .stein(.anzsteine-1).farbe
            startbreite = .stein(.anzsteine-1).breite
            starttyp    = .stein(.anzsteine-1).typ
            .anzSteine -= 1
            .zeichnen
            get (0, 0)-(FENSTERBREITE-1, FENSTERHOEHE-1), hintergrund
            zeichneStein mx-mxPlus, my-myPlus, startfarbe, startbreite,, starttyp
            .anzSteine += 1
            exit for
          end if
        end with
      next
      do
        getmouse mx, my,, mb
        if start >= 0 then
          screenlock
          put (0, 0), hintergrund, pset
          zeichneStein mx-mxPlus, my-myPlus, startfarbe, startbreite,, starttyp
          for i as integer = 0 to anzStoecke - 1
            with stock(i)
              if my - myPlus > .posY-STEINHOEHE*(.laenge+2) and my - myPlus < .posY-STEINHOEHE _
                   and mx -mxPlus > .posX-(STEINBREITE\2)*(.breite + startbreite + 2) _
                   and mx -mxPlus < .posX+(STEINBREITE\2)*(.breite - startbreite) then
                put (.posX-1.5*STEINBREITE, .posY+STEINBREITE), pfeil, trans
                exit for
              end if
            end with
          next
          screenunlock
        end if
        sleep 1
      loop until mb = 0
      ziel = -1
      if start >= 0 then
        for i as integer = 0 to anzStoecke - 1
          with stock(i)
            if my - myPlus > .posY-STEINHOEHE*(.laenge+2) and my - myPlus < .posY-STEINHOEHE _
                 and mx -mxPlus > .posX-(STEINBREITE\2)*(.breite + startbreite + 2) _
                 and mx -mxPlus < .posX+(STEINBREITE\2)*(.breite - startbreite) then
              ziel = i
              exit for
            end if
          end with
        next
        screenlock
        put (0, 0), hintergrund, pset
        if ziel > -1 then
          if stock(start).schiebeStein(stock(ziel)) then zuege += 1
          locate 2, 5
          print !"ben\148tigte Z\129ge: " & zuege
          stock(start).zeichnen
          stock(ziel).zeichnen
        else
          stock(start).zeichnen
        end if
        screenunlock
        ' Siegbedingung pruefen
        sieg = -1
        for i as integer = 0 to anzStoecke - 1
          for k as integer = 0 to stock(i).anzSteine-1
            if stock(i).farbe > 0 then
              if stock(i).stein(k).farbe <> stock(i).farbe then sieg = 0 : exit for, for
            else
              if siegbedingung(stock(i).stein(k).farbe) then sieg = 0 : exit for, for
            end if
          next
        next
      end if
    end if
    taste = inkey
    select case taste
      case "+" : if level < levelMax then exit do
      case "-" : if level > 1 then level -= 2 : exit do
      case chr(255, 107) : exit do, do
    end select
    sleep 1
  loop until sieg
  if sieg then
    locate FENSTERHOEHE\32-1, FENSTERBREITE\16 - 12
    print "LEVEL ERFOLGREICH BEENDET"
    locate , FENSTERBREITE\16 - 12
    print space(25)
    locate , FENSTERBREITE\16 - 12
    print !"  (Bitte Taste dr\129cken)  "
    getkey
  end if
  sieg = 0
  if level < levelMax then level += 1 else exit do
loop

' aufraeumen
for m as integer = 0 to 16
  imagedestroy maske(m)
next
imagedestroy pfeil

function laden(level as string, stock() as TypStock) as integer
  dim as integer f = freefile, anz = 0, gesamtbreite = 0, tempbreite, gesamthoehe = 0
  for i as integer = 0 to 9
    stock(i).constructor
  next
  if open("level/" & level & ".xml" for input as #f) then return 0
  dim as TypXML xml = xmlParse(, f), xmlIn
  close #f
  if xml.tag <> "sticks" then return 0
  xml.rest = xml.inhalt
  do
    if anz > 9 then return 0
    xml = xmlParse(xml.rest)
    if xml.tag = "stick" then
      with stock(anz)
        .breite = valint(xml.GetAttr("width"))
        tempbreite = stock(anz).breite
        .laenge = valint(xml.GetAttr("length"))
        if .laenge > 20 then return 0
        .farbe  = valint(xml.GetAttr("needs"))
        .typ    = 0
        if .laenge > gesamthoehe then gesamthoehe = .laenge
        if lcase(xml.GetAttr("type"))  = "pyramid" then .typ or= PYRAMIDE
        if lcase(xml.GetAttr("color")) = "single"  then .typ or= EINFARBIG
        xmlIn.rest = xml.inhalt
        do
          xmlIn = xmlParse(xmlIn.rest)
          if xmlIn.tag = "tile" then
            .stein(.anzSteine).breite = valint(xmlIn.GetAttr("width"))
            if lcase(xmlIn.GetAttr("type")) = "pyramid" then .stein(.anzSteine).typ or= PYRAMIDE
            if .stein(.anzSteine).breite > tempbreite andalso ERZWINGE_MAXBREITE then return 0
            if .anzSteine > 0 andalso .stein(.anzSteine).breite > .stein(.anzSteine-1).breite _
               andalso ERZWINGE_REIHENFOLGE then return 0
            .stein(.anzSteine).farbe = valint(xmlIn.inhalt)
            .anzSteine += 1
            if .anzSteine > 20 then return 0
          end if
        loop until xmlIn.rest = ""
        gesamtbreite += tempbreite + 2
        if gesamtbreite > FENSTERBREITE \ STEINBREITE then return 0
      end with
      anz += 1
    end if
  loop until xml.rest = ""
  tempbreite = 0
  for i as integer = 0 to anz-1
    stock(i).posX = (FENSTERBREITE + (stock(i).breite + i + 4 - gesamtbreite)*STEINBREITE)\2 + tempbreite
    stock(i).posY = (FENSTERHOEHE + (gesamthoehe+1)*STEINHOEHE)\2
    tempbreite += (stock(i).breite+1)*STEINBREITE
  next
  return anz
end function

sub zeichneStein(x as integer, y as integer, f as integer, byval b as integer, f2 as integer = 0, typ as integer = 0)
  dim as FB.IMAGE ptr hg   = imagecreate((b+1)*STEINBREITE, STEINHOEHE+2*(f>0), farbwert(f))
  dim as FB.IMAGE ptr bild = imagecreate((b+1)*STEINBREITE, STEINHOEHE+2*(f>0), 0)
  put hg, (0, 0), maske(b), and
  put bild, (0, 0), hg, alpha
  if typ and PYRAMIDE then
    for k as integer = 0 to STEINBREITE
      for i as integer = 0 to (STEINBREITE - k)\2
        pset bild, (i, k), &hff00ff
        pset bild, ((b+1)*STEINBREITE-1-i, k), &hff00ff
      next
    next
  end if
  put (x, y-(f>0)), bild, trans
  if f2 > 0 then
    line hg, (0, 0)-((b+1)*STEINBREITE-1, STEINHOEHE-1), farbwert(f2), bf
    put hg, (0, 0), maske(b), and
    if typ and PYRAMIDE then
      for k as integer = 0 to STEINBREITE
        for i as integer = 0 to (STEINBREITE - k)\2
          pset hg, (i, k), 0
          pset hg, ((b+1)*STEINBREITE-1-i, k), 0
        next
      next
    end if
    if b = 0 then
      put (x+STEINBREITE\2-2, y), hg, (STEINBREITE\2-1, 0)-step(3, STEINHOEHE), alpha
    else
      put (x, y+STEINHOEHE\2-2), hg, (0, 0)-step((b+1)*STEINBREITE-1, 4), alpha
    end if
  end if
  imagedestroy hg
  imagedestroy bild
end sub
